#ifndef _LISTSET_H_
#define _LISTSET_H_

#include "bmsfel.h"
#include "ttl.h"

class ListSet : public TtList {
protected:
  BmsBms *bms;
  BmsRegistArray *bms_ary;
  int channel_type;

  virtual DWORD  get_ex_style();
  virtual DWORD  get_style();
  virtual bool created();

  LRESULT wm_syskeydown_recved( int key, int info );
  LRESULT wm_key_down_recved( int key, int info );
  LRESULT wm_dropfiles_recved( HDROP h_drop );

public:
  virtual LRESULT wnd_proc( UINT msg, WPARAM w_param, LPARAM l_param );

  ListSet( BmsBms *bms, int channel_type );

  void set_bms( BmsBms *bms );
  BmsRegistArray *get_bms_ary();

  void update_at( BmsWord index, char *str );

  int repaint_all();
  int repaint_at( BmsWord index );

  bool exchange_upper();
  void no_use_erase();
  void fill();

  void ListSet::make_exist_list( bool exist_list[BmsWord::MAX] );

};

#endif // _LISTSET_H_
