#include "ttl_p.h"

DWORD  TtList::get_style()      { return WS_EX_CLIENTEDGE; }
DWORD  TtList::get_ex_style()   { return 0; }
PCTSTR TtList::get_class_name() { return "LISTBOX"; }


int TtList::get_count() {
  return SendMessage( this->h_wnd, LB_GETCOUNT, 0, 0 );
}

int TtList::get_text_at( int index, char *buf ) {
  return SendMessage( this->h_wnd, LB_GETTEXT, index, (LPARAM)buf );
}

int TtList::get_current() {
  return SendMessage( this->h_wnd, LB_GETCURSEL, 0, 0 );
}

int TtList::find( int start, const char *str ) {
  return SendMessage( this->h_wnd, LB_FINDSTRING, start, (LPARAM)str );
}


int TtList::push( const char *str ) {
  return SendMessage( this->h_wnd, LB_ADDSTRING, 0, (LPARAM)str );
}

int TtList::insert_at( int index, const char *str ) {
  return SendMessage( this->h_wnd, LB_INSERTSTRING, index, (LPARAM)str );
}


int TtList::delete_at( int index ) {
  return SendMessage( this->h_wnd, LB_DELETESTRING, index, 0 );
}

void TtList::clear() {
  SendMessage( this->h_wnd, LB_RESETCONTENT, 0, 0 );
}


int TtList::get_selected_count() {
  return SendMessage( this->h_wnd, LB_GETSELCOUNT, 0, 0 );
}

bool TtList::is_select( int index ) {
  return SendMessage( this->h_wnd, LB_GETSEL, index, 0 );
}

int TtList::set_select( int index ) {
  return SendMessage( this->h_wnd, LB_SETSEL, TRUE, index );
}

int TtList::unset_select( int index ) {
  return SendMessage( this->h_wnd, LB_SETSEL, FALSE, index );
}


int TtList::lock_draw() {
  return SendMessage( this->h_wnd, WM_SETREDRAW, FALSE, 0 );
}

int TtList::unlock_draw() {
  return SendMessage( this->h_wnd, WM_SETREDRAW, TRUE, 0 );
}

